=== modified file 'src/com/goldencode/p2j/ui/ProgressBar.java'
--- src/com/goldencode/p2j/ui/ProgressBar.java	2019-10-24 14:58:49 +0000
+++ src/com/goldencode/p2j/ui/ProgressBar.java	2020-02-25 17:03:00 +0000
@@ -2,10 +2,11 @@
 ** Module   : ProgressBar.java
 ** Abstract : ProgressBar widget interface.
 **
-** Copyright (c) 2019, Golden Code Development Corporation.
+** Copyright (c) 2019-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- --------------------------------Description-----------------------------------
 ** 001 MAG 20190919 Created initial version.
+** 002 SBI 20200225 Reused the common code.
 */
 
 /*
@@ -262,12 +263,6 @@
     */
    @LegacyMethod(name = "PB-VALUE")
    public void setValue(double value);
-
-   /**
-    * Refresh control.
-    */
-   @LegacyMethod(name = "PB-REFRESH")
-   public void progBarRefresh();
    
    /**
     * Get a value that determines whether the control displays progress with a standard segmented bar or a smooth bar.
@@ -297,56 +292,4 @@
     */
    @LegacyMethod(name = "PB-SCROLLING")
    public void setScrolling(int value);
-   
-   /**
-    * Get mouse pointer.
-    * 
-    * @return mouse pointer
-    */
-   @LegacyMethod(name = "PB-MOUSE-POINTER")
-   public integer getProgBarMousePointer();
-   
-   /**
-    * Set mouse pointer.
-    * 
-    * @param   value
-    *          new mouse pointer.
-    */
-   @LegacyMethod(name = "PB-MOUSE-POINTER")
-   public void setProgBarMousePointer(integer value);
-
-   /**
-    * Set mouse pointer.
-    * 
-    * @param   value 
-    *          new mouse pointer.
-    */
-   @LegacyMethod(name = "PB-MOUSE-POINTER")
-   public void setProgBarMousePointer(int value);
-   
-   /**
-    * Get mouse icon.
-    * 
-    * @return mouse icon
-    */
-   @LegacyMethod(name = "PB-MOUSE-ICON")
-   public character getMouseIcon();
-   
-   /**
-    * Sets a custom mouse icon.
-    * 
-    * @param   value
-    *          user defined mouse icon
-    */
-   @LegacyMethod(name = "PB-MOUSE-ICON")
-   public void setMouseIcon(character value);
-
-   /**
-    * Sets a custom mouse icon.
-    * 
-    * @param   value
-    *          user defined mouse icon
-    */
-   @LegacyMethod(name = "PB-MOUSE-ICON")
-   public void setMouseIcon(String value);   
 }

=== modified file 'src/com/goldencode/p2j/ui/ProgressBarConfig.java'
--- src/com/goldencode/p2j/ui/ProgressBarConfig.java	2019-12-13 08:58:45 +0000
+++ src/com/goldencode/p2j/ui/ProgressBarConfig.java	2020-02-24 05:15:18 +0000
@@ -71,7 +71,7 @@
  * Contains data for PROGRESS-BAR widget.
  */
 public class ProgressBarConfig 
-extends OcxDragDropConfig
+extends WidgetConfigExt
 {
    /** The Progress Bar PB-APPEARANCE attribute. */
    public int appearance = CC_3D;

=== modified file 'src/com/goldencode/p2j/ui/ProgressBarWidget.java'
--- src/com/goldencode/p2j/ui/ProgressBarWidget.java	2019-12-13 08:58:45 +0000
+++ src/com/goldencode/p2j/ui/ProgressBarWidget.java	2020-02-25 17:02:05 +0000
@@ -2,10 +2,11 @@
 ** Module   : ProgressBarWidget.java
 ** Abstract : Implementation of server side PROGRESS-BAR widget.
 **
-** Copyright (c) 2019, Golden Code Development Corporation.
+** Copyright (c) 2019-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- --------------------------------Description-----------------------------------
 ** 001 MAG 20190923 Created initial version.
+** 002 SBI 20200225 Reused the common code.
 */
 
 /*
@@ -63,22 +64,18 @@
 
 package com.goldencode.p2j.ui;
 
-import com.goldencode.p2j.ui.ocx.*;
 import com.goldencode.p2j.util.*;
 
 import static com.goldencode.p2j.ui.client.gui.ProgressBarGui.*;
-import static com.goldencode.p2j.ui.ocx.IVBDataObject.*;
+import static com.goldencode.p2j.util.Utils.*;
 
 /**
  * Server side PROGRESS-BAR widget implementation.
  */
 public class ProgressBarWidget
-extends ControlEntity<ProgressBarConfig>
+extends ControlEntityExt<ProgressBarConfig>
 implements ProgressBar
 {
-   /* PB-COM-DATA */
-   private comhandle comData = DataObject.newInstance(this);
-
    /**
     * Default constructor.
     */
@@ -191,7 +188,7 @@
       {
          ErrorManager.recordOrShowError(5990, String.format(
                   "Error occured while accessing component property/method: Appearance\n"
-                  + "Invalid property value\n%s %s", type(), widgetName()), true);                     
+                  + "Invalid property value\n%s %s", type(), widgetName()), true);
       }            
    }
 
@@ -242,7 +239,7 @@
       {
          ErrorManager.recordOrShowError(5990, String.format(
                   "Error occured while accessing component property/method: BorderStyle\n"
-                  + "Invalid property value\n%s %s", type(), widgetName()), true);                     
+                  + "Invalid property value\n%s %s", type(), widgetName()), true);
       }
    }
    
@@ -287,13 +284,13 @@
       if (isValidValue(value, CC_ORIENTATION_HORIZONTAL, CC_ORIENTATION_VERTICAL))
       {
          config.orientation = value;
-         pushWidgetAttr("orientation", config.orientation);         
+         pushWidgetAttr("orientation", config.orientation);
       }
       else
       {
          ErrorManager.recordOrShowError(5990, String.format(
                   "Error occured while accessing component property/method: Orientation\n"
-                  + "Invalid property value\n%s %s", type(), widgetName()), true);                     
+                  + "Invalid property value\n%s %s", type(), widgetName()), true);
       }
    }
 
@@ -339,7 +336,7 @@
       {
          ErrorManager.recordOrShowError(5990, String.format(
                   "Error occured while accessing component property/method: Min\n"
-                  + "Invalid property value\n%s %s", type(), widgetName()), true);            
+                  + "Invalid property value\n%s %s", type(), widgetName()), true);
       }
       else
       {
@@ -399,7 +396,7 @@
       {
          ErrorManager.recordOrShowError(5990, String.format(
                   "Error occured while accessing component property/method: Max\n"
-                  + "Invalid property value\n%s %s", type(), widgetName()), true);            
+                  + "Invalid property value\n%s %s", type(), widgetName()), true);
       }
       else
       {
@@ -459,11 +456,11 @@
       {
          ErrorManager.recordOrShowError(5990, String.format(
                   "Error occured while accessing component property/method: Value\n"
-                  + "Invalid property value\n%s %s", type(), widgetName()), true);            
+                  + "Invalid property value\n%s %s", type(), widgetName()), true);
       }
       else
       {         
-         config.value = value;            
+         config.value = value;
          pushWidgetAttr("value", config.value);
       }      
    }
@@ -490,68 +487,6 @@
     * {@inheritDoc}
     */
    @Override
-   public void progBarRefresh()
-   {
-      LogicalTerminal.refreshWidget(config.id.asInt());
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public integer getProgBarMousePointer()
-   {
-      return new integer(config.mousePointer);
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setProgBarMousePointer(int value)
-   {
-      if (config.mousePointer == value)
-      {
-         return;
-      }
-      
-      if (isValidValue(value, CC_DEFAULT, CC_ARROW, CC_CROSS, CC_IBEAM, CC_ICON, CC_SIZE, CC_SIZE_NESW, 
-               CC_SIZE_NS, CC_SIZE_NWSE, CC_SIZE_EW, CC_UP_ARROW,  CC_HOURGLASS, CC_NO_DROP, 
-               CC_ARROW_HOURGLASS, CC_ARROW_QUESTION, CC_SIZE_ALL, CC_CUSTOM))
-      {
-         config.mousePointer = value;
-         pushWidgetAttr("mousePointer", config.mousePointer);
-      }
-      else
-      {
-         ErrorManager.recordOrShowError(5990, String.format(
-                  "Error occured while accessing component property/method: MousePointer\n"
-                  + "Invalid property value\n%s %s", type(), widgetName()), true);                     
-      }            
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setProgBarMousePointer(integer value)
-   {
-      if (value.isUnknown())
-      {
-         ErrorManager.recordOrShowError(4083, String.format(
-               "Unable to assign UNKNOWN value to attribute MOUSE-POINTER on %s %s", type(),
-                  widgetName()), false);
-      }
-      else
-      {
-         setProgBarMousePointer(value.intValue());
-      }
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
    public integer getScrolling()
    {
       return new integer(config.scrolling);
@@ -577,7 +512,7 @@
       {
          ErrorManager.recordOrShowError(5990, String.format(
                   "Error occured while accessing component property/method: Scrolling\n"
-                  + "Invalid property value\n%s %s", type(), widgetName()), true);                     
+                  + "Invalid property value\n%s %s", type(), widgetName()), true);
       }      
    }
 
@@ -598,534 +533,4 @@
          setScrolling(value.intValue());
       }
    }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public integer getOleDropMode()
-   {
-      return new integer(config.oleDropMode);
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setOleDropMode(int value)
-   {
-      super.setDropTarget(value == IVBDataObject.DROP_MANUAL);
-      
-      if (config.oleDropMode == value)
-      {
-         return;
-      }
-      
-      if (isValidValue(value, DROP_MANUAL, DROP_NONE))
-      {         
-         config.oleDropMode = value;
-         pushWidgetAttr("oleDropMode", config.oleDropMode);
-      }
-      else
-      {
-         ErrorManager.recordOrShowError(5990, String.format(
-                  "Error occured while accessing component property/method: OLEDropMode\n"
-                  + "Invalid property value\n%s %s", type(), widgetName()), true);                     
-      }
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setOleDropMode(integer value)
-   {
-      if (value.isUnknown())
-      {
-         ErrorManager.recordOrShowError(4083, String.format(
-               "Unable to assign UNKNOWN value to attribute OLE-DROP-MODE on %s %s", type(),
-                  widgetName()), false);
-      }
-      else
-      {
-         setOleDropMode(value.intValue());
-      }
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void oleDrag()
-   {
-      LogicalTerminal.oleDrag(config.id.asInt());
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public character getMouseIcon()
-   {
-      return new character(config.mouseIcon);
-   }
-   
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setMouseIcon(String value)
-   {
-      if (!config.realized)
-      {
-         if (config.mouseIcon == value)
-         {
-            return;
-         }
-         
-         config.mouseIcon = value;
-         pushWidgetAttr("mouseIcon", config.mouseIcon);
-      }
-      else
-      {
-         ErrorManager.recordOrShowError(4053, String.format(
-               "Unable to set MOUSE-ICON because the %s %s has been realised", type(),
-                  widgetName()), false);
-      }                              
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setMouseIcon(character value)
-   {
-      if (value.isUnknown())
-      {
-         ErrorManager.recordOrShowError(4083, String.format(
-               "Unable to assign UNKNOWN value to attribute MOUSE-ICON on %s %s", type(),
-                  widgetName()), false);
-      }
-      else
-      {
-         setMouseIcon(value.getValue());
-      }
-   }
-   
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public integer getMouseButton()
-   {
-      return new integer(config.mouseButton);
-   }
-   
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public integer getMouseShift()
-   {
-      return new integer(config.mouseShift);
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public integer getMouseX()
-   {
-      return new integer(config.mouseX);
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public integer getMouseY()
-   {
-      return new integer(config.mouseY);
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public integer getEffect()
-   {
-      return new integer(config.oleEffect);
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setEffect(int value)
-   {
-      if (config.oleEffect == value)
-      {
-         return;
-      }
-      
-      if (isValidValue(value, NONE, COPY, MOVE, SCROLL))
-      {
-         config.oleEffect = value;
-         pushWidgetAttr("oleEffect", config.oleEffect);
-      }
-      else
-      {
-         ErrorManager.recordOrShowError(5990, String.format(
-                  "Error occured while accessing component property/method: Effect\n"
-                  + "Invalid property value\n%s %s", type(), widgetName()), true);                     
-      }
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setEffect(integer value)
-   {
-      if (value.isUnknown())
-      {
-         ErrorManager.recordOrShowError(4083, String.format(
-               "Unable to assign UNKNOWN value to attribute OLE-EFFECT on %s %s", type(),
-                  widgetName()), false);
-      }
-      else
-      {
-         setEffect(value.intValue());
-      }
-   }
-   
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public comhandle getComData()
-   {
-      return comData;
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setComData(comhandle value)
-   {
-      // no-op
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public decimal getOleX()
-   {
-      return new decimal(config.oleX);
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setOleX(double value)
-   {
-      if (!config.realized)
-      {
-         if (config.oleX == value)
-         {
-            return;
-         }
-         
-         config.oleX = value;
-         pushWidgetAttr("oleX", config.oleX);
-      }
-      else
-      {
-         ErrorManager.recordOrShowError(4053, String.format(
-               "Unable to set OLE-X because the %s %s has been realised", type(),
-                  widgetName()), false);
-      }                                   
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setOleX(decimal value)
-   {
-      if (value.isUnknown())
-      {
-         ErrorManager.recordOrShowError(4083, String.format(
-               "Unable to assign UNKNOWN value to attribute OLE-X on %s %s", type(),
-                  widgetName()), false);
-      }
-      else
-      {
-         setOleX(value.doubleValue());
-      }
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public decimal getOleY()
-   {
-      return new decimal(config.oleY);
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setOleY(double value)
-   {
-      if (!config.realized)
-      {
-         if (config.oleY == value)
-         {
-            return;
-         }
-         
-         config.oleY = value;
-         pushWidgetAttr("oleY", config.oleY);
-      }
-      else
-      {
-         ErrorManager.recordOrShowError(4053, String.format(
-               "Unable to set OLE-Y because the %s %s has been realised", type(),
-                  widgetName()), false);
-      }                                   
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setOleY(decimal value)
-   {
-      if (value.isUnknown())
-      {
-         ErrorManager.recordOrShowError(4083, String.format(
-               "Unable to assign UNKNOWN value to attribute OLE-Y on %s %s", type(),
-                  widgetName()), false);
-      }
-      else
-      {
-         setOleY(value.doubleValue());
-      }
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public integer getState()
-   {
-      return new integer(config.state);
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setState(int value)
-   {
-      if (config.oleState == value)
-      {
-         return;
-      }
-      
-      config.oleState = value;
-      pushWidgetAttr("oleState", config.oleState);
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setState(integer value)
-   {
-      if (value.isUnknown())
-      {
-         ErrorManager.recordOrShowError(4083, String.format(
-               "Unable to assign UNKNOWN value to attribute OLE-STATE on %s %s", type(),
-                  widgetName()), false);
-      }
-      else
-      {
-         setState(value.intValue());
-      }
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public logical isDefaultCursors()
-   {
-      return new logical(config.oleDefaultCursors);
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setDefaultCursors(boolean value)
-   {
-      if (config.oleDefaultCursors == value)
-      {
-         return;
-      }
-      
-      config.oleDefaultCursors = value;
-      pushWidgetAttr("oleDefaultCursors", config.oleDefaultCursors);
-   }
-   
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setDefaultCursors(logical value)
-   {
-      if (value.isUnknown())
-      {
-         ErrorManager.recordOrShowError(4083, String.format(
-               "Unable to assign UNKNOWN value to attribute DEFAULT-CURSORS on %s %s", type(),
-                  widgetName()), false);
-      }
-      else
-      {
-         setDefaultCursors(value.booleanValue());
-      }
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public integer getDataFormat()
-   {
-      return new integer(config.oleDataFormat);
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setDataFormat(int value)
-   {
-      if (config.oleDataFormat == value)
-      {
-         return;
-      }
-            
-      if (isValidValue(value, CF_TEXT, CF_BITMAP, CF_METAFILE, CF_DIB, 
-               CF_PALETTE, CF_EMETAFILE, CF_FILES, CF_RTF))
-      {         
-         config.oleDataFormat = value;
-         pushWidgetAttr("oleDataFormat", config.oleDataFormat);
-      }
-      else
-      {
-         ErrorManager.recordOrShowError(5990, String.format(
-                  "Error occured while accessing component property/method: DataFormat\n"
-                  + "Invalid property value\n%s %s", type(), widgetName()), true);                     
-      }
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setDataFormat(integer value)
-   {
-      if (value.isUnknown())
-      {
-         ErrorManager.recordOrShowError(4083, String.format(
-               "Unable to assign UNKNOWN value to attribute DATA-FORMAT on %s %s", type(),
-                  widgetName()), false);
-      }
-      else
-      {
-         setDataFormat(value.intValue());
-      }
-   }
-   
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public integer getAllowedEffects()
-   {
-      return new integer(config.oleAllowedEffects);
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setAllowedEffects(int value)
-   {
-      if (config.oleAllowedEffects == value)
-      {
-         return;
-      }
-      
-      if (isValidValue(value, NONE, COPY, MOVE, SCROLL))
-      {
-         config.oleAllowedEffects = value;
-         pushWidgetAttr("oleAllowedEffects", config.oleAllowedEffects);
-      }
-      else
-      {
-         ErrorManager.recordOrShowError(5990, String.format(
-                  "Error occured while accessing component property/method: AllowedEffects\n"
-                  + "Invalid property value\n%s %s", type(), widgetName()), true);                     
-      }
-   }
-
-   /**
-    * {@inheritDoc}
-    */
-   @Override
-   public void setAllowedEffects(integer value)
-   {
-      if (value.isUnknown())
-      {
-         ErrorManager.recordOrShowError(4083, String.format(
-               "Unable to assign UNKNOWN value to attribute ALLOWED-EFFECTS on %s %s", type(),
-                  widgetName()), false);
-      }
-      else
-      {
-         setAllowedEffects(value.intValue());
-      }
-   }
-   
-   /**
-    * Check if a given value is a valid value.
-    * 
-    * @param   value
-    *          Value to check.
-    * @param   validValues
-    *          List of valid values.
-    *          
-    * @return  <code>true</code> if value is in the list of valid values <code>false</code> otherwise.
-    */
-   private boolean isValidValue(int value, int ... validValues)
-   {
-      for (int v : validValues)
-      {
-         if (value == v)
-         {
-            return true;
-         }
-      }
-      
-      return false;
-   }
 }

=== modified file 'src/com/goldencode/p2j/ui/WidgetConfigDef.java'
--- src/com/goldencode/p2j/ui/WidgetConfigDef.java	2020-01-30 15:38:58 +0000
+++ src/com/goldencode/p2j/ui/WidgetConfigDef.java	2020-02-25 17:00:48 +0000
@@ -22,6 +22,7 @@
 ** 012 HC  20200128 Removed client-server widget config definitions synchronization. Client and
 **                  server config managers can now be dynamically extended with new widget
 **                  configurations.
+** 013 SBI 20200225 Added Calendar widget support.
 */
 
 /*
@@ -223,6 +224,10 @@
       {
          return (T) new ControlSetConfig();
       }
+      else if (cfgCls == CalendarConfig.class)
+      {
+         return (T) new CalendarConfig();
+      }
       else if (cfgCls == EditorConfig.class)
       {
          return (T) new EditorConfig();

=== added file 'src/com/goldencode/p2j/ui/WidgetConfigExt.java'
--- src/com/goldencode/p2j/ui/WidgetConfigExt.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/WidgetConfigExt.java	2020-02-25 16:17:41 +0000
@@ -0,0 +1,193 @@
+/*
+** Module   : WidgetConfigExt.java
+** Abstract : Contains data specific for WidgetExtension
+**
+** Copyright (c) 2020, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ---------------------------------Description---------------------------------
+** 001 SBI 20200223 Created initial version.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.ui;
+
+import java.io.*;
+
+
+/**
+ * Contains data for widgets that implements WidgetExtension.
+ */
+public class WidgetConfigExt 
+extends OcxDragDropConfig
+{
+   /** Mouse Pointer constants */
+   public static final int CC_DEFAULT          = 0;
+   public static final int CC_ARROW            = 1;
+   public static final int CC_CROSS            = 2;
+   public static final int CC_IBEAM            = 3;
+   public static final int CC_ICON             = 4;
+   public static final int CC_SIZE             = 5;
+   public static final int CC_SIZE_NESW        = 6;
+   public static final int CC_SIZE_NS          = 7;
+   public static final int CC_SIZE_NWSE        = 8;
+   public static final int CC_SIZE_EW          = 9;
+   public static final int CC_UP_ARROW        = 10;
+   public static final int CC_HOURGLASS       = 11;
+   public static final int CC_NO_DROP         = 12;
+   public static final int CC_ARROW_HOURGLASS = 13;
+   public static final int CC_ARROW_QUESTION  = 14;
+   public static final int CC_SIZE_ALL        = 15;
+   public static final int CC_CUSTOM          = 99;
+   
+   /** The MOUSE-ICON attribute. */
+   public String mouseIcon;
+
+   /** The MOUSE-POINTER-NUM attribute. */
+   public int mousePointer;
+
+   /**
+    * Default constructor (only used in de-serialization).
+    */
+   public WidgetConfigExt()
+   {
+   }
+
+   /**
+    * Create a new config and associate it with the given widget.
+    * 
+    * @param    id
+    *           The ID of the widget to which this configuration belongs.
+    */
+   protected WidgetConfigExt(int id)
+   {
+      super(id);
+   }
+
+   /**
+    * Create a new config and associate it with the given widget.
+    * 
+    * @param    id
+    *           The ID of the widget to which this configuration belongs.
+    */
+   protected WidgetConfigExt(WidgetId id)
+   {
+      super(id);
+   }
+
+   /**
+    * Set new values from the provided configuration instance.
+    * 
+    * @param    config
+    *           The instance from which to take values.
+    */
+   @Override
+   public void applyConfig(WidgetConfig config)
+   {
+      super.applyConfig(config);
+
+      if (!(config instanceof WidgetConfigExt))
+      {
+         return;
+      }
+
+      WidgetConfigExt cfg = (WidgetConfigExt) config;
+
+      mouseIcon = cfg.mouseIcon;
+      mousePointer = cfg.mousePointer;
+   }
+
+   /**
+    * Replacement for the default object reading method. The latest
+    * state is read from the input source.  The parent's state is
+    * read first.
+    * 
+    * @param    in
+    *           The input source from which fields will be restored.
+    *
+    * @throws   IOException
+    *           In case of I/O errors.
+    * @throws   ClassNotFoundException
+    *           If payload can't be instantiated.
+    */
+   @Override
+   public void readExternal(ObjectInput in) 
+   throws IOException, 
+          ClassNotFoundException
+   {
+      super.readExternal(in);
+      mouseIcon = (String) in.readObject();
+      mousePointer = in.readInt();
+   }
+
+   /**
+    * Replacement for the default object writing method. The latest
+    * state is written to the output destination.  The parent's state is
+    * written first.
+    * 
+    * @param    out
+    *           The output destination to which fields will be saved.
+    *
+    * @throws   IOException
+    *           In case of I/O errors.
+    */
+   @Override
+   public void writeExternal(ObjectOutput out) 
+   throws IOException
+   {
+      super.writeExternal(out);
+      out.writeObject(mouseIcon);
+      out.writeInt(mousePointer);
+   }
+}

